;; ----------------------------------------------------------------------------
;; books.scm -- ɤ
;; ----------------------------------------------------------------------------

(kern-mk-sprite-set 'ss_books 32 32 2 2 0 0 "books.png")

(kern-mk-sprite 's_lexicon ss_books 1 0 #f 0)
(kern-mk-sprite 's_manual  ss_books 1 1 #f 0)
(kern-mk-sprite 's_scroll  ss_books 1 2 #f 0)

;; Fixme: see if something like this will work for books:
(define (mk-book tag name . text)
  (mk-reusable-item 
   tag name s_manual norm
   (lambda ()
     (kern-ui-page-text text))))

;;----------------------------------------------------------------------------
;; player manual
(define (basic-survival-manual-commands)
  (kern-ui-page-text
   "̿"
   "(ƥ󥭡)Ǽ"
   "ESC򲡤̿Ǥ롣"
   "ƬʸΥ򲡤̿¹Ԥ롣"
   "ܺ٤ϥޥ˥奢ɤळȡ"
   ""
   "A)򹶷⤹"
   "B)ʤɤ˾"
   "C)ʸ򾧤"
   "E)Įƶ"
   "F)ˤʤɤˤ⤹"
   "G)֤줿Τ"
   "H)С䵡"
   "K)٥åɤǵ©"
   "L)Ф餯Ĥ"
   "N)ѹ"
   "O)Ȣʤɤ򳫤"
   "Q)λ"
   "R)ɶ"
   "S)줿Τõ"
   "T)ïä"
   "U)ʪȤ"
   "Y)ǽϤȤ"
   "Z)֤ɽ"
   "X)Ĵ٤"
   "@)֤ˤĤɽ"
   "<space> ⤷ʤ"
   "CTRL-S)λ¸"
   "CTRL-R)Ǹ¸֤ɤ߹"
   "SHIFT+륭 ̤򥹥뤹"
   "<Tab>ե٥åȡ޻"
   )
  result-ok)

(mk-reusable-item 't_manual "Ӥ뤿μ" s_manual (/ norm 3)
                  basic-survival-manual-commands)

;;----------------------------------------------------------------------------
;; ƻդμ
(mk-reusable-item 
 't_letter_from_enchanter "פʼ" s_lexicon norm
 (lambda (klexicon kuser)
   (kern-ui-page-text
    "¤ͤ  "
   ""
   "Ǥ^c+r^c-ʤΤϡ򸫤Ĥ뤳Ȥ"
   "Ťδ򤷤ƤԤƻ򶵤Ƥ"
   ""
   "Ĥơ"
   ""
   "ƻ\n"
   )
   (quest-data-assign-once 'questentry-calltoarms)
   result-ok))

;;----------------------------------------------------------------------------
;; book of the demon gate
(mk-reusable-item 
 't_demon_gate_book "ܥܥʸ" s_scroll v-hard
 (lambda (kbook kuser)
   (kern-ui-page-text
   ""
   ""
   "ĸŤԤƸʬ"
   ""
   "λ뤳ȤϤʤ"
   "ޤǤϡ"
   "Ͽ¤ؤƻ򸸳Ф"
   "ƻϡ򤫤ʼԤˤϻǤ뤫Τ褦˸"
   ""
   ""
   "ήؤȤɤ"
   ""
   "򳫤ԤϡĶϤ"
   ""
   "ĥΥեԤäƤ롣"
   ""
   "Ծʥեǥå\n"
   )
   result-ok))

;;----------------------------------------------------------------------------
;; 㥹μ
(mk-reusable-item 
 't_kathryns_letter "" s_scroll norm
 (lambda (kletter kuser)
   (kern-ui-page-text
   ""
   "ˤ"
   "ƻդǤΰĤäƤ롣̣"
   "Ǥ줬ɬפäΤäƤΤ"
   "ƤƤϤʤʤ˴Ǥ"
   "ݣӤ")
   result-ok))


;;----------------------------------------------------------------------------
;; The soliloquy from Hamlet:
(mk-reusable-item 
 't_playbook_hamlet "" s_scroll norm
 (lambda (kletter kuser)
   (kern-ui-page-text
   "ܤΰ"

   "To be, or not to be: that is the question:"
   "Whether 'tis nobler in the mind to suffer"
   "The slings and arrows of outrageous fortune,"
   "Or to take arms against a sea of troubles,"
   "And by opposing end them? To die: to sleep;"
   "No more; and by a sleep to say we end"
   "The heart-ache and the thousand natural shocks"
   "That flesh is heir to, 'tis a consummation"
   "Devoutly to be wish'd. To die, to sleep;"
   "To sleep: perchance to dream: ay, there's the rub;"
   ""
   "For in that sleep of death what dreams may come"
   "When we have shuffled off this mortal coil,"
   "Must give us pause: there's the respect"
   "That makes calamity of so long life;"
   ""
   "For who would bear the whips and scorns of time,"
   "The oppressor's wrong, the proud man's contumely,"
   "The pangs of despised love, the law's delay,"
   "The insolence of office and the spurns"
   "That patient merit of the unworthy takes,"
   "When he himself might his quietus make"
   "With a bare bodkin? who would fardels bear,"
   "To grunt and sweat under a weary life,"
   "But that the dread of something after death,"
   "The undiscover'd country from whose bourn"
   "No traveller returns, puzzles the will"
   "And makes us rather bear those ills we have"
   "Than fly to others that we know not of?"
   ""
   "Thus conscience does make cowards of us all;"
   "And thus the native hue of resolution"
   "Is sicklied o'er with the pale cast of thought,"
   "And enterprises of great pith and moment"
   "With this regard their currents turn awry,"
   "And lose the name of action.--Soft you now!"
   "The fair Ophelia! Nymph, in thy orisons"
   "Be all my sins remember'd."
   )))

;;----------------------------------------------------------------------------
;; Spell books
(mk-reusable-item 
 't_ylem_an_ex_book "ʸ: YAE" s_manual hard
 (lambda (kletter kuser)
   (kern-ui-page-text
   " - Ylem An Ex"
   ""
   "鿴ԤΤʼʸ"
   "֤Ǳ󤯤Ũ館δֿư"
   "褦ˤ뤳ȤǤ롣"
   ""
   "ޤȤС֤ǰŪϩɤȤ"
   "롣鿴Ԥˤ񤷤⤷ʤ"
   ""
   "μʸˤϡλ夬ɬפ"
   "ɸ˸äФ˹ɬפǤ롣"
   ""
   "Ĵ礷顢Ylem An Ex(ʪΡաͳ)"
   "Ⱦ֤Ũ˸äȯͤ뤳ȡ"
   ) 
   result-ok))

(mk-reusable-item 
 't_bet_flam_hur_book "ʸ: BFH" s_manual hard
 (lambda (kletter kuser)
   (kern-ui-page-text
   "̸ - Bet Flam Hur"
   ""
   "μʸθ̤Τ񤷤"
   "ޤפ㤷ᡢۤȤɤ"
   "ѻդǽϤĶΤǤ롣"
   ""
   "β̸μʸϡμʸǤ˺ƹ"
   "ΤǤ롣󾧤ԤǽϤ⤤"
   "ɸ̤"
   ""
   "̸μʸϰϤĹ٤Ƥ⤽ۤ"
   "Ϥʤ˱μʸΤ褦˾˱"
   "ϤĤȤϤǤʤ"
   ""
   "μʸˤϡϤΤβγǽ"
   "ȯưΤιƱ߿˹"
   "ηݤɬפǤ롣"
   ""
   "Ĵ礷顢Bet Flam Hur(С)Ⱦ"
   "Ũ򴬤߿ؼ뤳ȡ"
   )
   result-ok))

(mk-reusable-item
 't_ranger_orders "Ĺ̿" s_scroll norm
 (lambda (kletter kuser)
   (kern-ui-page-text
    "Ĺ̿"
    ""
    "̿ļԤϡ̾Ū˻"
    "֤ȤǤ롣")
   result-ok))

(mk-reusable-item
 't_prisoner_receipt "ƾ" s_scroll norm
 (lambda (kletter kuser)
   (kern-ui-page-text
    "ƾ"
    ""
    "ξϰͤμͤǼϤȤ"
    "ΤǤ롣")
   result-ok))


;;;;;;;;;;;;;;;;;;;; White Magick ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_white_magick_1 "ˡ: 촬" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "ˡ: 촬"
    "μʸ"
    ""
    "MĴ礻衡 "
    "٤ȤCǾ衡 "
    "Ǥ"
    " ۤɤμפ̡ "
    ""
    " <AN NOX>"
    "- ͻ"
    ""
    " <AN ZU>"
    "- ͻ"
    ""
    " <MANI>"
    "- ͻλ"
    )
   result-ok))

(mk-reusable-item
 't_spell_book_white_magick_2 "ˡ: ˴"  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "ˡ: "
    "ݸμʸ"
    ""
    "ĴȱӾθΤ졡"
    "¿αפǤ"
    "˺ʡθ̳򡡡"
    "ƤͿ衡"
    ""
    " <Sanct Nox>"
    "- ǡʥȥɡ륱"
    ""
    "Ѳ <In Flam Sanct>"
    "- βγǡ[]"
    ""
    "æˡ <An Ort Xen>"
    "- βγǡޥɥ쥤"
    ""
    "ݸ <IN SANCT>"
    "- βγǡͻ"
    ""
    " <VAS AN NOX>"
    "- ǡͻޥɥ쥤"
    ""
    " <VAS MANI>"
    "- ͻλ塢ޥɥ쥤"
    )
   result-ok))

(mk-reusable-item
 't_spell_book_white_magick_3 "ˡ: 軰"  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "ˡ: 軰"
    "̤μˡ"
    ""
    "Ĵ礻衡ƴμ衡衪"
    "󤻤衡ᤤϤ򡪡"
    "򤬸ФǤǤ"
    " KAL WIS - IN MANI - AN CORP - ZU QUAS  "
    ""
    " <VAS AN NOX>"
    "- ͻǡޥɥ쥤"
    ""
    " <VAS SANCT NOX>"
    "- ǡʥȥɡޥɥ쥤"
    "  륱"
    ""
    " <VAS MANI>"
    "- ͻλ塢ޥɥ쥤"
    ""
    ""
    " ̤ˡ "
    ""
    " <IN MANI CORP>"
    "- ͻǡλ塢βγݡ"
    "  ޥɥ쥤"
    ""
    "  ٤Ԥ򻦤ƤϤʤ̡"
    "  ݵ٤٤Ԥɤ餻ƤϤʤ̡"

    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Force Magick ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_force_magick_12 ": 촬" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": 촬"
    "Ϥμʸء"
    ""
    "           MĴ礻            "
    "       ٤ȤCǾ        "
    "       ϤŨ˶ݤΤ餷         "
    "    򤬶򤫤Ǥʸ϶ˤͿ롪    "
    ""
    ":"
    ""
    "ˡ <GRAV POR>"
    "- βγ"
    ""
    " <IN LOR>"
    "- βγ"
    ""
    ""
    ":"
    ""
    "Ѳ <REL HUR>"
    "- βγ"
    ""
    "̸ <BET FLAM HUR>"
    "- βγݡ"
    ""
    "Ƿ <IN NOX POR>"
    "- ʥȥɡݡ"
    )
   result-ok))

(mk-reusable-item
 't_spell_book_force_magick_battle ": Ʈ"  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": Ʈ"
    ""
    "ƮӾĴ礻衡"
    "ƮϡӤ衡"
    "Ũ϶Τ˻̤Ǥ"
    "ϤˤϺ񤫡Ȥ"
    ""
    ":"
    ""
    "ˡ <GRAV POR>"
    "- βγ"
    ""
    " <ORT GRAV>"
    "- βγޥɥ쥤"
    ""
    ""
    "軰:"
    ""
    "е <VAS FLAM>"
    "- βγ"
    ""
    "Ѳ <IN FLAM SANCT>"
    "- βγ[Ǥ][α]"
    ""
    ""
    "ϻ:"
    ""
    "Ͽ <IN VAS POR YLEM>"
    "- βγݡޥɥ쥤"
    )
   result-ok))


(mk-reusable-item
't_spell_book_force_magick_winds ": "  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": "
    ""
    "ΤĴ礻衡Τ˾衪"
    "Ũ̲ꡡ̵ϤΤǤ"
    "ŨǤ졡Ƥ졡줷Ǥ"
    "θѤ٤"
    "θѤɬפʤСѤ餺"
    "ǤѤ뤫"
    ""
    "ء:"
    ""
    " <BET YLEM HUR>"
    "- βγ"
    ""
    "Ѳ <REL HUR>"
    "- βγ"
    ""
    "̸ <BET FLAM HUR>"
    "- βγݡ"
    ""
    ""
    "輷:"
    ""
    "̲ <IN ZU HUR>"
    "- ͻݡޥɥ쥤"
    ""
    " <IN NOX HUR>"
    "- βγݡʥȥ"
    ""
    ""
    "Ȭ:"
    ""
    " <IN FLAM HUR>"
    "- βγݡޥɥ쥤"
    )
   result-ok))
(mk-reusable-item
't_spell_book_force_magick_matter ": "  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": "
    ""
    "Ĵ礷衡Ϥۤ롡"
    "ϤϾޤǰ롡"
    "ʤ顡𤬤狼Ǥ"
    "Ŵ̩ϡʽ餫ˡ"
    "Ӥβϡĳˡ"
    ""
    "ء:"
    ""
    "櫲 <AN SANCT YLEM>"
    "- "
    ""
    " <AN SANCT>"
    "- βγ"
    ""
    "ܾ <SANCT>"
    "- βγλ"
    ""
    "Ѳ <REL HUR>"
    "- βγ"
    ""
    ""
    "ϻ:"
    ""
    "Ͽ <IN VAS POR YLEM>"
    "- βγݡޥɥ쥤"
    ""
    "ǰ <IN REL POR>"
    "- λ塢ݡ"
    ""
    ""
    "[]"
    ""
    " <VAS UUS YLEM>"
    "- ߣޥɥ쥤"
    "- ߣ[Ǥ]ܡ"
    "- ܡε¡á"
    )
   result-ok))

(mk-reusable-item
't_spell_book_force_magick_mechanismus ": "  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": "
    ""
    "ΡĴ硡ʪӾ"
    "٤櫡ζҤϲ᤮롪"
    "ʤϳ"
    "Ĥ̵̤ϤǤ롪"
    "®ݤơήԤݤơ"
    "֤ݤ(뤤Ϥη)"
    "μʸСĤ򡡡"
    "åʤ餺ԤϤʤ"
    ""
    "ء:"
    ""
    "櫲 <An Sanct Ylem>"
    "- "
    ""
    " <An Sanct>"
    "- βγ"
    ""
    "ܾ <Sanct>"
    "- βγλ"
    ""
    ""
    "޿:"
    ""
    " <In Ex Por>"
    "- βγ"
    ""
    " <An Ex Por>"
    "- βγǡ"
    )
   result-ok))

(mk-reusable-item
't_spell_book_force_magick_fields ": ΰ"  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": ΰ"
    ""
    "Ĵ礷衡Ϥ򡡡"
    "̲ꡡǡꡡ롡"
    "뤤ˤä졡"
    "  IN GRAV - AN POR - AN GRAV - EX POR   "
    ""
    "軰:"
    ""
    "̲ <In Zu Grav>"
    "- ͻλ塢"
    ""
    "Ǿ <In Nox Grav>"
    "- λ塢ʥȥ"
    ""
    "б <In Flam Grav>"
    "- βγλ塢"
    ""
    ""
    "Ϳ:"
    ""
    " <In Sanct Grav>"
    "- λ塢ޥɥ쥤"
    ""
    "æˡ <An Grav>"
    "- βγ"
    )
   result-ok))

(mk-reusable-item
't_spell_book_force_magick_high_magick ": ˡ"  s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": ˡ"
    ""
    "ѿ衡Ϥۤɶʤ"
    "ѿ衡ϸʤ"
    "˽񤫤줷Ϲ̤ˡǤ롡"
    "򤬶򤫤ʤ顡ϻ̤Ǥ"
    "˵٤Ϥ򡡡"
    ""
    "ϻ - ̵ϲ <In An>"
    "- βγǡޥɥ쥤"
    ""
    "輷 -  <Xen Corp>"
    "- ޥɥ쥤"
    ""
    "Ȭ -  <In Vas Grav Corp>"
    "- βγʥȥɡޥɥ쥤"
    ""
    "Ȭ -  <An Tym>"
    "- ǡݡޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Necromancy ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_necromancy "Ի뵷" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "Ի뵷"
    ""
    "Sanctus Corporem ex Nihilo, Rel Oculume "
    "De Vermiis Mysteriis, Astralis Sangrem  "
    ""
    " - Ի <An Xen Corp>"
    "- βγ"
    ""
    "Ȭ - Իྤ <Kal Xen Corp>"
    "- λ塢ʥȥɡޥɥ쥤"
    ""
    " - Ƿ <In Nox Por>"
    "- ݡʥȥ"
    ""
    "輷 -  <In Nox Hur>"
    "- βγݡʥȥ"
    ""
    "輷 -  <Xen Corp>"
    "- ʥȥ"
    ""
    "輷 - ʣ <In Quas Xen>"
    "- βγͻλ塢ݡ"
    "  ʥȥɡޥɥ쥤"
    ""
    "Ȭ -  <In Mani Corp>"
    "- βγͻǡλ塢ݡ"
    "  ޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Summoning ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_summoning ": ä¸" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": ä¸"
    ""
    "KAL        դ - դ      KAL "
    "CORP         ƤӽФԤ         XEN "
    "BET       ֤ȤϤǤ      ORT "
    "SANCT  [ABRAD] - [ACAD] - [ABRA]   YLEM "
    ""
    " -  <In Bet Xen>"
    "- βγݡλ"
    ""
    "޿ - þ <Kal Xen>"
    "- λ塢ޥɥ쥤"
    ""
    "Ȭ - ͻ <Kal Xen Nox>"
    "- λ塢ʥȥɡޥɥ쥤"
    ""
    "Ȭ - Իྤ <Kal Xen Corp>"
    "- λ塢ʥȥɡޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Dimensions and Gate Magick ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_gate_magick ": " s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": "
    ""
    "˸ơõԤ衡ιϡ˼ͳǤ롡"
    "      IN POR - IN WIS - EX POR WIS      "
    ""
    "θۤ롪"
    "ۡݥե24(12,12) "
    "ݥߥ60(5)x8 "
    "ݥɡġ36(9)x8 "
    ""
    "ʤ顡礱򸫤訢"
    ""
    " <In Wis>"
    "- ʥȥ"
    ""
    "Τ <In Quas Wis>"
    "- ʥȥɡޥɥ쥤"
    ""
    "ķ <Bet Por>"
    "- ݡ"
    ""
    "徺 <Uus Por>"
    "- Ĵ礹٤餺٤餺"
    "  ˤȤ롪"
    ""
    " <Des Por>"
    "- 櫤դ衪"
    "  θõ٤餺"
    ""
    "® <Rel Tym>"
    "- βγݡޥɥ쥤"
    ""
    "ְִư <Vas Por>"
    "- ݡޥɥ쥤"
    ""
    " <Vas Rel Por>"
    "- βγޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Enchantment ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_enchantment_wards "볦: ɸ" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "볦: ɸ"
    ""
    "SANCT -      򼫿Ȥ졪     - SANCT "
    "Ĵ礻衪μʸ򾧤衪"
    "μϤξ줬ʤ"
    "õԤ-ϴκˤꡪ-դ訢"
    ""
    " <Sanct Nox>"
    "- ǡʥȥɡ륱"
    ""
    "Ѳ <In Flam Sanct>"
    "- [][]ߤβҤδ"
    ""
    " <Vas Sanct Nox>"
    "- ǡʥȥɡޥɥ쥤"
    "  륱"
    ""
    "ݸ <In Sanct>"
    "- βγͻ"
    ""
    "æˡ <An Ort Xen>"
    "- βγǡޥɥ쥤"
    ""
    "̵ϲ <In An>"
    "- βγǡޥɥ쥤"
    ""
    " <In Sanct Grav>"
    "- λ塢ޥɥ쥤"
    )
   result-ok))

(mk-reusable-item
 't_spell_book_enchantment_curses "볦: " s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "볦: "
    ""
    "ɤԤء"
    "衡θå"
    ""
    "ɤԤءݡ졡"
    "ɬפȤСĴ礷衡"
    ""
    " <Ylem An Ex>"
    "- λ塢"
    ""
    " <An Xen Bet>"
    "- ǡλ"
    ""
    "̲ <Xen Zu>"
    "- ͻλ"
    ""
    "̥λ <An Xen Ex>"
    "- λ塢ʥȥ"
    ""
    " <Quas An Wis>"
    "- ʥȥɡޥɥ쥤"
    ""
    " <In Quas Corp>"
    "- ǡʥȥɡޥɥ쥤"
    )
   result-ok))

(mk-reusable-item
 't_spell_book_enchantment_miscellanea "볦: Ͽ" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "볦: Ͽ"
    ""
    "[ܤ䤱ʸ]ѡ[ˤ]"
    "[̣ʸ]鱣줿[]"
    "AN EX WIS -                  - KAL QUAS "
    ""
    "® <Rel Tym>"
    "- βγݡޥɥ쥤"
    ""
    "Ʃ <Wis An Ylem>"
    "- βγޥɥ쥤"
    ""
    "ԲĻ <Sanct Lor>"
    "- ݡʥȥɡޥɥ쥤"
    ""
    "ǰ <In Rel Por>"
    "- λ塢ݡ"
    ""
    " <In Nox Hur>"
    "- βγݡʥȥ"
    ""
    "̲ <In Zu Hur>"
    "- ͻݡޥɥ쥤"
    ""
    " <An Tym>"
    "- ǡݡޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Illusions, Misdirections, and Schemes ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_spell_book_illusion_1 ": " s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": "
    ""
    "Ϥʤ餺Ԥѻդ"
    "άѤ"
    "μʸȤ٤Ĵ礷衡"
    ""
    " <Bet Ylem Hur>"
    "- βγ"
    ""
    "õ <Wis Sanct>"
    "- βγ"
    ""
    "̲ <Xen Zu>"
    "- ͻλ"
    ""
    " <An Xen Bet>"
    "- ǡλ"
    )
   result-ok))

(mk-reusable-item
't_spell_book_illusion_2 ": " s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    ": "
    ""
    "ťβʤ줿ѻդ"
    "ǹκά"
    "ޤѤ"
    "Ӥ롡"
    "Ĵ礷ʸ򾧤衡"
    "ٹ𡡡"
    "򤫼Ԥ줷ᤵʡ"
    ""
    " <Quas An Wis>"
    "- ʥȥɡޥɥ쥤"
    ""
    "̥λ <An Xen Ex>"
    "- λ塢ʥȥ"
    ""
    " <In Quas Corp>"
    "- ǡʥȥɡޥɥ쥤"
    ""
    "ԲĻ <Sanct Lor>"
    "- ݡʥȥɡޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Divination Magick ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
't_spell_book_divination "ͽΤ뵷" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "ͽΤ뵷"
    ""
    "    IN WIS - AN QUAS - VAS KAL EX WIS   "
    "õԤϸΤ郎򤱨"
    "õԤõ᤹롡ݤΤݤ"
    "Ϥʤ餺Ԥ٤Ͽͤ롡"
    "ï"
    ""
    "õ <Wis Sanct>"
    "- βγ"
    ""
    "櫲 <An Sanct Ylem>"
    "- "
    ""
    " <In Wis>"
    "- ʥȥ"
    ""
    "Τ <In Quas Wis>"
    "- ʥȥɡޥɥ쥤"
    ""
    "Ļ <Wis Quas>"
    "- βγʥȥ"
    ""
    "Ʃ <Wis An Ylem>"
    "- βγޥɥ쥤"
    )
   result-ok))


;;;;;;;;;;;;;;;;;;;; Master Spellbook ;;;;;;;;;;;;;;;;;;;;

(mk-reusable-item
 't_basic_spell_book "ʸ" s_manual (/ norm 3)
 (lambda (kbook kuser)
   (kern-ui-page-text
    "ʸ"
    ""
    ""
    " MĴ礷ʸ졡"
    " CǤ٤Ȥ˾衡"
    "ΩĤǤ"
    "˸ơɤȤդ٤"
    ""
    "                                           "
    "ġġġġġġġġġġġġġġġġġ"
    " ͻ                      λ    "
    "                             "
    "β βγ                        "
    " ʥȥ            ޥɥ쥤"
    " 륱                        "
    "ġġġġġġġġġʸġġġġġġġġ"
    "  "
    "An Nox                             "
    "An Zu                              "
    "Grav Por         ˡ       β       "
    "In Lor                        β         "
    "Mani                             "
    "Wis Sanct        õ         β         "
    "An Sanct Ylem    櫲                  "
    "Ylem An Ex                           "
    "Bet Ylem Hur                β         "
    " ˿ "
    "Sanct Nox                        "
    "An Sanct                    β       "
    "Sanct            ܾ           β       "
    "An Xen Corp      Ի           β     "
    "In Wis                               "
    "In Bet Xen                    β "
    "Rel Hur          Ѳ         β       "
    "In Nox Por       Ƿ                "
    "An Xen Bet                       "
    "Bet Flam Hur     ̸             β   "
    "In Quas Wis      Τ                "
    "Xen Zu           ̲                  "
    " 軰 "
    "In Flam Grav     б         β     "
    "In Nox Grav      Ǿ                "
    "In Zu Grav       ̲              "
    "Vas Flam         е             β     "
    "Vas Lor                     β       "
    "In Flam Sanct    Ѳ             β   "
    "Vas An Nox                     "
    "An Ort Xen       æˡ             β "
    " Ϳ "
    "An Grav          æˡ         β     "
    "In Sanct Grav                    "
    "In Sanct         ݸ           β     "
    "Wis Quas         Ļ             β     "
    "Bet Por          ķ                  "
    "Vas Sanct Nox                "
    "Ort Grav                        β "
    " ޿ "
    "In Ex Por               β       "
    "An Ex Por                   β     "
    "In Zu            ̲              "
    "Vas Mani                       "
    "Rel Tym          ®         β     "
    "Kal Xen          þ                "
    "Rel Xen Quas     ø                "
    " ϻ "
    "In An                           β "
    "Wis An Ylen      Ʃ             β     "
    "An Xen Ex        ̥λ                "
    "In Vas Por Ylem  Ͽ               β "
    "Quas An Wis                        "
    "Vas Uus Ylem                     "
    "In Rel Por       ǰ                "
    "Vas Por          ְִư            "
    " 輷 "
    "In Nox Hur                    β,  "
    "In Zu Hur        ̲              "
    "In Quas Corp                     "
    "Sanct Lor        ԲĻ              "
    "Xen Corp                             "
    "In Quas Xen      ʣ           ʥβط"
    " Ȭ "
    "Kal Xen Nox      ͻ                "
    "In Flam Hur                   β   "
    "In Vas Grav Corp              β   "
    "An Tym                       "
    "Kal Xen Corp     Իྤ            "
    "In Mani Corp                β"
    "Vas Rel Por                   β     "
    )
   result-ok))
   
;;----------------------------------------------------------------------------
;; Anaxes letters
(mk-reusable-item
 't_anaxes_letter "ʥƤμ" s_scroll v-hard
 (lambda (kletter kuser)
   (kern-ui-page-text
    ""
    ""
    "ʥ"
    ""
    "κǰοͤءͤϤʤޤ"
    "(饯ޥˤŰŪ˶Ƥޤ)"
    "ϸŤĤػߤ̿ȯᤷޤ"
    "ʳο򿮤Τϡߤʼ줿Ԥ"
    "äƤޤ"
    ""
    "񤤤Ƥ뺣饹ɥȥȥޥ"
    "緳֥ǥɤܻؤƤޤ"
    "餬ʤΤȤ夹ݤ˹Ԥޤ"
    "ε̵̤ˤʤʤ褦"
    "Ƥ"
    ""
    "͡ܤƤƤϤʤ"
    "΢ڤޤȤʤäƵǲ񤤤ޤ"
    "ƥ줬䤿Ũˤʧ碌"
    "ޤ褦ˡ"
    ""
    "롢"
    ""
    ""
    "ɿϰǤ򸫤ΤϤߤ"
    "ݤޤ"
    )
   result-ok))

;;----------------------------------------------------------------------------
;; Stewardess's Journal
;;
;; TODO: update last entry time to match when warritrix quest becomes available
;; Journal should not be updated if stolen by wanderer (This would also destroy its applicability as evidence)
;;
(mk-reusable-item 
 't_stewardess_journal "ȥꥢ" s_lexicon norm
 (lambda (klexicon kuser)
   (kern-ui-page-text
    "ȥꥢ"
    ""
    "1610ǯ13"
    "⤷ƮΤäͭ̾ˤʤä顢ϸȻ"
    "Ƚʼʤ뤫⤷"
    "ȤդʤƤϡ⤷"
    "ȡֲͧפˤʤ뤫⤷ʤ"
    "礭ߤ롣ѤǤ뤫Ϥ狼ʤ"
    ""
    ""
    ""
    ""
    "1610ǯ1113"
    "Ĥ˥륹Ȥ¤ɤ뤳ȤǤ"
    "äƤĤξξڵ򡢤ĤԲʤ"
    "蘆बæΤߤǤȤȤ"
    "äΤ⤷˼"
    "αʤС˾򤫼Ԥˤ"
    "ǤäǤϤϿä⤷ʤ"
    "ҤεͿ٤ǤϤʤ"
    ""
    ""
    ""
    "1611ǯ41"
    "Ӥ¤ͤΤ蘆ޤäƤΤ餻Ƥ"
    "ӤƻबɤǾ"
    "ƤΤΤꤿΤʤ¤"
    "ΤȤ򤽤ʤ˵ˤƤΤ"
    "ϸĥ줿Τ˰㤤ʤǸ¤ͤ"
    "줿ΤϸŤΥɤ⤷Ƥ"
    "Ȥ⤷ä¤ʤС"
    ""
    ""
    ""
    "1611ǯ612"
    "ӤäȤθդä"
    "ե꡼ˡ줿Ʋ򤷤ƤĴ"
    "٤˽ʵͤ롢Ȥ蘆Ƥ"
    "ĤƮΤ̾Ф"
    "ŽѻդǤϤʤͤΥɤ⤬ͽ"
    "ۤϤӤظƻ뤳"
    "Ȥ«Ƥ줿ƨƻϤʤˤä"
    "Ƥ⡢κ᤬뤳ȤϤʤΤȤ"
    "򤫤ʥե꡼Ǥ"
    ""
    "ȽΤϤï⸫"
    "Ĥ뤳ȤϤǤʤƤ⤷䤬"
    "ڤνˤʤäȤˤϡ˲ȤϤ"
    "ɬפȤ"
    ""
    ""
   )
   result-ok))
